.386
.model flat,stdcall
option casemap:none

include WINDOWS.INC

include kernel32.inc
include user32.inc
includelib kernel32.lib
includelib user32.lib

include disasm.inc
includelib disasm.lib
includelib crtmt.lib

IDI_ICON100		EQU 100
IDD_DLG1001		EQU 1001
IDC_EDIT1002	EQU 1002
IDC_EDIT1003	EQU 1003

.data
hInst dd ?
asmmodel t_asmmodel <>

.const
szFmt db "0x%02x ",0
szSep db " -> ",0
szCaption db "Assembly error!",0

.code
align DWORD
AppendText proc hWnd:HWND, pszText:PTR CHAR
	local orig:CHARRANGE
	local new:CHARRANGE
	
	; Appends a text string to an edit box.
	mov orig.cpMin,-1
	mov orig.cpMax,-1
	invoke SendMessage,hWnd,EM_EXGETSEL,0,addr orig
	mov new.cpMin,-1
	mov new.cpMax,-1
	invoke SendMessage,hWnd,EM_EXSETSEL,0,addr new
	invoke SendMessage,hWnd,EM_REPLACESEL,FALSE,pszText
	invoke SendMessage,hWnd,EM_EXSETSEL,0,addr orig
	ret
	
AppendText endp

align DWORD
OpcodesToHex proc uses ebx esi edi pszOutput:PTR CHAR
	local szTemp[8]:CHAR
	
	; Converts the opcodes to hexa values.
	invoke lstrcpy,pszOutput,addr szSep
	mov ebx,asmmodel._length
	lea esi,asmmodel.code
	lea edi,asmmodel._mask
	test ebx,ebx
	.while !zero?
		xor eax,eax
		mov al,[esi]
		and al,[edi]
		mov szTemp[0],0
		invoke wsprintf,addr szTemp,offset szFmt,eax
		invoke lstrcat,pszOutput,addr szTemp
		inc esi
		inc edi
		dec ebx
	.endw
	mov dword ptr szTemp[0],00000A0Dh
	invoke lstrcat,pszOutput,addr szTemp
	ret
	
OpcodesToHex endp

align DWORD
DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	local hwndOut:HWND
	local szError[TEXTLEN]:CHAR
	local szCommand[TEXTLEN]:CHAR
	local szBinary[TEXTLEN]:CHAR
	
	mov eax,uMsg
	.if eax == WM_COMMAND
		mov eax,wParam
		.if eax == IDOK
			
			; Assemble the current command and append the opcodes (converted to hexa values).
			invoke GetDlgItem,hWnd,IDC_EDIT1003
			.if eax
				mov hwndOut,eax
				invoke GetDlgItemText,hWnd,IDC_EDIT1002,addr szCommand,sizeof szCommand
				.if eax
					mov szError[0],0
					invoke Assemble,addr szCommand,0,addr asmmodel,0,4,addr szError
					.if (SDWORD ptr eax) >= 0
						invoke OpcodesToHex,addr szBinary
						invoke AppendText,hwndOut,addr szCommand
						invoke AppendText,hwndOut,addr szBinary
						invoke SetDlgItemText,hWnd,IDC_EDIT1002,NULL
					.else
						invoke MessageBox,hWnd,addr szError,addr szCaption,MB_ICONERROR or MB_OK
					.endif
				.endif
			.endif
			
		.elseif eax == IDCANCEL
			
			; Close the dialog box.
			invoke EndDialog,hWnd,wParam
			
		.endif
	.elseif eax == WM_INITDIALOG
		
		; Initialize the dialog box.
		invoke LoadIcon,hInst,IDI_ICON100
		invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
		push TRUE
		pop eax
		ret
		
	.endif
	xor eax,eax
	ret
	
DlgProc endp

start proc
	
	; Launch the main dialog box.
	invoke GetModuleHandle,NULL
	mov hInst,eax
	invoke DialogBoxParam,eax,IDD_DLG1001,0,offset DlgProc,0
	invoke ExitProcess,0
	
start endp

end start
